package com.jforeach.mazegame;

import android.graphics.Bitmap;
import android.graphics.Canvas;

public abstract class Character {
	protected boolean isDirty;
	
	protected int currentX, currentY;
	protected Bitmap bitmap_w;
	protected Bitmap bitmap_d;
	protected boolean isDrinking = false;
	protected int id;
	protected static final int UP = 0, DOWN = 1, RIGHT = 2, LEFT = 3;
	
	public Character() {
				
	}
	
	public void SetBitmapW(Bitmap bitmap)
	{
		this.bitmap_w = bitmap;
	}
	public void SetBitmapD(Bitmap bitmap) {
		this.bitmap_d = bitmap;
	}
	
	public void Draw(Canvas canvas, Maze maze, GameView view) {
		
		if (isDrinking) canvas.drawBitmap(bitmap_d, currentX* view.getTotalCellWidth(), currentY* view.getTotalCellHeight(), null); 
		else canvas.drawBitmap(bitmap_w, currentX* view.getTotalCellWidth(), currentY* view.getTotalCellHeight(), null);
	}
	
	public void Update() {
		
	}
	
	
	public void Move(int direction, Maze maze) {
		boolean moved = false;
		
		
		
		if(direction == UP) {
			if(currentY != 0 && !maze.getHorizontalLines()[currentY-1][currentX]) {
				currentY--;
				moved = true;
			}
		}
		if(direction == DOWN) {
			if(currentY != maze.getMazeHeight()-1 && !maze.getHorizontalLines()[currentY][currentX]) {
				currentY++;
				moved = true;
			}
		}
		if(direction == RIGHT) {
			if(currentX != maze.getMazeWidth()-1 && !maze.getVerticalLines()[currentY][currentX]) {
				currentX++;
				moved = true;
			}
		}
		if(direction == LEFT) {
			if(currentX != 0 && !maze.getVerticalLines()[currentY][currentX-1]) {
				currentX--;
				moved = true;
			}
		}
		if(moved) {
			isDirty = true;
		
		}
		
	}
	
	public int getCurrentX() {
		return currentX;
	}
	public int getCurrentY() {
		return currentY;
	}
	
	public boolean getDirty() {
		return isDirty;
	}
	
	public void setDirty() {
		isDirty = false;
	}
	public void setDrinking(boolean d) {
		isDrinking = d;
	}
	

}
