package com.jforeach.mazegame;

import java.text.DecimalFormat;

import android.graphics.Bitmap;
import android.graphics.Canvas;
import android.opengl.Matrix;
import android.util.Log;


public class Player extends Character {
	
	public static final int UP = 0, DOWN = 1, RIGHT = 2, LEFT = 3;
	private int latestMove;
	private boolean passedOut = false;
	private Bitmap bitmap_p;
	
	//private int currentX = 0,currentY = 0;
	private static Player instance = null;
	
	private double blood_alcohol;
	
	
	private Player() {
		super();
		
		blood_alcohol = 0.7; // over drink drive limit by default
		id = 1;
		
	}
	public static Player getInstance() {
		if (instance == null) {
			instance = new Player();
		}
		return instance;
	}
	
	public void Draw(Canvas canvas, Maze maze, GameView view) {
//		canvas.drawCircle((currentX * view.getTotalCellWidth())+(view.getCellWidth()/2),   //x of center
//				  (currentY * view.getTotalCellHeight())+(view.getCellWidth()/2),  //y of center
//				  (view.getCellWidth()*0.45f),                           //radius
//				  view.getRed());
		
		
		
//		canvas.drawBitmap(bitmap_w, currentX* view.getTotalCellWidth(), currentY* view.getTotalCellHeight(), null);
		
		if (!passedOut) {
			
		super.Draw(canvas, maze, view);
		canvas.drawText("F: " + Double.valueOf((new DecimalFormat("#.##")).format(blood_alcohol)),
		(3 * view.getTotalCellWidth() )+(view.getCellWidth()*0.25f),
		(0 * view.getTotalCellHeight())+(view.getTotalCellHeight()*0.75f),
		view.getRed());
		}
		else {
			canvas.drawBitmap(bitmap_p, currentX* view.getTotalCellWidth(), currentY* view.getTotalCellHeight(), null);
		}

	}
	
	public void MovePlayer(int x, int y, int width, int height, Maze maze) {
		int direction = ResolveDirection(x,y, width, height, maze);
		Move(direction, maze);
		latestMove = direction;
		
	}
	

	public int ResolveDirection(int x, int y, int width, int height, Maze maze) {

		
		if (y *  maze.getMazeWidth() / width < currentY && x * maze.getMazeWidth() / width == currentX) 
			return UP;
			
			
		if (y *  maze.getMazeWidth() / width >= currentY && x * maze.getMazeWidth() / width == currentX)
			return DOWN;
	
		if (x * maze.getMazeWidth() / width > currentX && y * maze.getMazeWidth() / width == currentY ) 
			return RIGHT;

		if (x * maze.getMazeWidth() / width < currentX && y * maze.getMazeWidth() / width == currentY ) 
			return LEFT;
		
		else return 99;
		
		
	}
	
	public void setBloodAlcohol(double x) {
		blood_alcohol = x;
	}
	
	public double getBloodAlcohol() {
		return blood_alcohol;
	}
	
	public int getLatestDirection() {
		return latestMove;
	}
	
	public void setPassedOut() {
		passedOut = true;
	}
	
	public boolean getPassedOut() {
		return passedOut;
	}
	
	public void setBitmapP (Bitmap b) {
		bitmap_p = b;
	}

	
	
}
